/* const ejecutarSincrono = (comando) => {
  try {
    return execSync(comando)
  } catch (err) {
    let mensaje = "Problemas al ejecutar el comando: " + comando
    alert(mensaje)
    console.log(mensaje)
    return "error"
  }
} */

const util = require('util');
const miexec = util.promisify(require('child_process').exec);

// eslint-disable-next-line no-unused-vars
const store = new Vuex.Store({
  state: {
    paso: 1, // paso de la post-instalación
    mostrar: false,
    info: {
      pasarsiguiente: {
        value: false
      },
      mostrar: {
        value: false,
        default: false
      },
      paso: {
        value: 0
      },
      escentro: { // Indica que e usa el equipo en un centro educativo
        value: null,
        value: false
      },
      ipcache: {
        value: "172.30.1.249",
        default: "172.30.1.249"
      },
      usuiniciosesion: {
        value: null
      },
      mostrarnuevousuario: {
        value: false
      },
      // Nombre del equipo:
      equipo: {
        value: null,
        default: "vitalinux"
      },
      // Datos del nuevo usuario en caso de querer iniciar sesión con un usuario no existente:
      nombrecompletousu: {
        value: null
      },
      nombreusu: {
        value: null
      },
      perfilusu: {
        value: null
      },
      passusu: {
        value: null
      }
    },
    lisetmigasfreeall: null,
    lisetmigasfreeset: null
  },
  getters: {
    lisEtSelec(state) {
      return state.lisetmigasfreeall != null ? state.lisetmigasfreeall.filter((item) => item.seleccionado) : null
    },
    listaEtFinal(state, getters) {
      return getters.lisEtSelec != null ? getters.lisEtSelec.map(item => item.etiqueta) : null
    }
  },
  mutations: {
    ModificarListaEtiquetas(state, {
      name
    }) {
      state.lisetmigasfreeall.filter((item) => item.etiqueta === name)[0].seleccionado = !state.lisetmigasfreeall.filter((item) => item.etiqueta === name)[0].seleccionado
    },
    ModificarPaso(state, {
      npaso
    }) {
      state.paso = npaso
    },
    ModificarEsCentro(state, {
      valor
    }) {
      state.escentro = valor
    },
    ModificarMostrar(state) {
      state.mostrar = true
    },
    ModificarInfo(state, {
      name,
      value
    }) {
      console.log("Ha llegado a la mutación: " + name + " y " + value)
      //state.info.filter(campo => campo.name === name)[0].value = value
      state.info[name].value = value
    },
    ModificarEtiquetas(state, {
      lista1,
      lista2
    }) {
      state.lisetmigasfreeset = lista1
      state.lisetmigasfreeall = lista2
    }
  },
  actions: {
    ModificarListaEtiquetas({
      commit
    }, {
      name
    }) {
      console.log("Vamos a modificar la etiqueta: " + name)
      commit('ModificarListaEtiquetas', {
        name
      })
    },
    ModificarInfo(context, {
      name,
      value
    }) {
      //console.log("Han llegado a la Actions: " + name + " y " + value)
      let datos = {
        name: name,
        value: value
      }
      context.commit('ModificarInfo', datos)
    },
    async myEtMigasfree({
      commit
    }) {
      let comando = 'sudo migasfree-tags -g'
      const res1 = await miexec(comando);
      let lista1 = null
      let lista2 = null
      if (res1.stderr) {
        console.error(`Error al ejecutar ${comando}: ${res1.stderr}`);
        return null
      }
      console.log(`Etiquetas Asignadas: ${res1.stdout.toString().replace(/['"]+/g,'')}`);
      lista1 = res1.stdout.toString().replace(/['"]+/g, '').trim().split(" ")
      const {
        stdout,
        stderr
      } = await miexec('sudo migasfree-tags -a');
      if (stderr) {
        console.error(`error: ${stderr}`);
        return null
      }
      let objeto = JSON.parse(stdout)
      let listado = Object.keys(objeto)
        .map(key => objeto[key])
        .toString()
        .split(",");
      lista2 = listado.map((et, index) => {
        return {
          etiqueta: `${et}`,
          //seleccionado: false, // Por defecto false, a no ser que la etiqueta ya este asignada
          seleccionado: lista1.includes(et) ? true : false,
          indice: index
        }
      })
      console.log("El listado de etiquetas disponibles esssss: ")
      console.log(lista2)
      let datos = {
        lista1: lista1,
        lista2: lista2
      }
      commit('ModificarEtiquetas', datos)
    },
    ModificarPaso(context, npaso) {
      context.commit('ModificarPaso', {
        npaso
      })
    },
    ModificarEsCentro(context, valor) {
      console.log("Se modifica el valor de centro: " + valor)
      context.commit('ModificarEsCentro', {
        valor
      })
    },
    ModificarMostrar(context) {
      context.commit('ModificarMostrar')
    }
  }
});
